/* MainWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2011-2023 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Maxwell Barvian <maxwell@elementary.io>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <handy.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <granite.h>
#include <libecal/libecal.h>
#include "elementary-calendar.h"
#include <libedataserver/libedataserver.h>
#include <cairo-gobject.h>

#define MAYA_MAIN_WINDOW_ACTION_PREFIX "win."
#define MAYA_MAIN_WINDOW_ACTION_NEW_EVENT "action_new_event"
#define MAYA_MAIN_WINDOW_ACTION_SHOW_TODAY "action_show_today"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MAYA_TYPE_MAIN_WINDOW (maya_main_window_get_type ())
#define MAYA_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_TYPE_MAIN_WINDOW, MayaMainWindow))
#define MAYA_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_TYPE_MAIN_WINDOW, MayaMainWindowClass))
#define MAYA_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_TYPE_MAIN_WINDOW))
#define MAYA_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_TYPE_MAIN_WINDOW))
#define MAYA_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_TYPE_MAIN_WINDOW, MayaMainWindowClass))

typedef struct _MayaMainWindow MayaMainWindow;
typedef struct _MayaMainWindowClass MayaMainWindowClass;
typedef struct _MayaMainWindowPrivate MayaMainWindowPrivate;

#define MAYA_VIEW_TYPE_CALENDAR_VIEW (maya_view_calendar_view_get_type ())
#define MAYA_VIEW_CALENDAR_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_VIEW_TYPE_CALENDAR_VIEW, MayaViewCalendarView))
#define MAYA_VIEW_CALENDAR_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_VIEW_TYPE_CALENDAR_VIEW, MayaViewCalendarViewClass))
#define MAYA_VIEW_IS_CALENDAR_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_VIEW_TYPE_CALENDAR_VIEW))
#define MAYA_VIEW_IS_CALENDAR_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_VIEW_TYPE_CALENDAR_VIEW))
#define MAYA_VIEW_CALENDAR_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_VIEW_TYPE_CALENDAR_VIEW, MayaViewCalendarViewClass))

typedef struct _MayaViewCalendarView MayaViewCalendarView;
typedef struct _MayaViewCalendarViewClass MayaViewCalendarViewClass;
enum  {
	MAYA_MAIN_WINDOW_0_PROPERTY,
	MAYA_MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* maya_main_window_properties[MAYA_MAIN_WINDOW_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MAYA_VIEW_TYPE_EVENT_DIALOG (maya_view_event_dialog_get_type ())
#define MAYA_VIEW_EVENT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_VIEW_TYPE_EVENT_DIALOG, MayaViewEventDialog))
#define MAYA_VIEW_EVENT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_VIEW_TYPE_EVENT_DIALOG, MayaViewEventDialogClass))
#define MAYA_VIEW_IS_EVENT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_VIEW_TYPE_EVENT_DIALOG))
#define MAYA_VIEW_IS_EVENT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_VIEW_TYPE_EVENT_DIALOG))
#define MAYA_VIEW_EVENT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_VIEW_TYPE_EVENT_DIALOG, MayaViewEventDialogClass))

typedef struct _MayaViewEventDialog MayaViewEventDialog;
typedef struct _MayaViewEventDialogClass MayaViewEventDialogClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_ECalComponentId_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentId_free (var), NULL)))

#define MAYA_TYPE_APPLICATION (maya_application_get_type ())
#define MAYA_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_TYPE_APPLICATION, MayaApplication))
#define MAYA_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_TYPE_APPLICATION, MayaApplicationClass))
#define MAYA_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_TYPE_APPLICATION))
#define MAYA_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_TYPE_APPLICATION))
#define MAYA_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_TYPE_APPLICATION, MayaApplicationClass))

typedef struct _MayaApplication MayaApplication;
typedef struct _MayaApplicationClass MayaApplicationClass;

#define MAYA_VIEW_TYPE_AGENDA_VIEW (maya_view_agenda_view_get_type ())
#define MAYA_VIEW_AGENDA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_VIEW_TYPE_AGENDA_VIEW, MayaViewAgendaView))
#define MAYA_VIEW_AGENDA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_VIEW_TYPE_AGENDA_VIEW, MayaViewAgendaViewClass))
#define MAYA_VIEW_IS_AGENDA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_VIEW_TYPE_AGENDA_VIEW))
#define MAYA_VIEW_IS_AGENDA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_VIEW_TYPE_AGENDA_VIEW))
#define MAYA_VIEW_AGENDA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_VIEW_TYPE_AGENDA_VIEW, MayaViewAgendaViewClass))

typedef struct _MayaViewAgendaView MayaViewAgendaView;
typedef struct _MayaViewAgendaViewClass MayaViewAgendaViewClass;
typedef struct _Block4Data Block4Data;

struct _MayaMainWindow {
	HdyApplicationWindow parent_instance;
	MayaMainWindowPrivate * priv;
	MayaViewCalendarView* calview;
};

struct _MayaMainWindowClass {
	HdyApplicationWindowClass parent_class;
};

struct _MayaMainWindowPrivate {
	guint configure_id;
};

struct _Block4Data {
	int _ref_count_;
	MayaMainWindow* self;
	MayaViewAgendaView* sidebar;
};

static gint MayaMainWindow_private_offset;
static gpointer maya_main_window_parent_class = NULL;
static GeeMultiMap* maya_main_window_action_accelerators;
static GeeMultiMap* maya_main_window_action_accelerators = NULL;
VALA_EXTERN GSettings* maya_application_saved_state;

VALA_EXTERN GType maya_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MayaMainWindow, g_object_unref)
VALA_EXTERN GType maya_view_calendar_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MayaViewCalendarView, g_object_unref)
static void maya_main_window_action_new_event (MayaMainWindow* self);
static void _maya_main_window_action_new_event_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void maya_main_window_action_show_today (MayaMainWindow* self);
static void _maya_main_window_action_show_today_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
VALA_EXTERN MayaMainWindow* maya_main_window_new (GtkApplication* application);
VALA_EXTERN MayaMainWindow* maya_main_window_construct (GType object_type,
                                            GtkApplication* application);
VALA_EXTERN void maya_main_window_on_tb_add_clicked (MayaMainWindow* self,
                                         GDateTime* dt);
VALA_EXTERN GType maya_view_event_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MayaViewEventDialog, g_object_unref)
VALA_EXTERN MayaViewEventDialog* maya_view_event_dialog_new (ECalComponent* ecal,
                                                 GDateTime* date_time,
                                                 GtkWindow* parent);
VALA_EXTERN MayaViewEventDialog* maya_view_event_dialog_construct (GType object_type,
                                                       ECalComponent* ecal,
                                                       GDateTime* date_time,
                                                       GtkWindow* parent);
VALA_EXTERN GDateTime* maya_view_calendar_view_get_selected_date (MayaViewCalendarView* self);
VALA_EXTERN void maya_view_calendar_view_today (MayaViewCalendarView* self);
static void maya_main_window_on_remove (MayaMainWindow* self,
                                 ECalComponent* comp);
VALA_EXTERN void maya_main_window_on_modified (MayaMainWindow* self,
                                   ECalComponent* comp);
VALA_EXTERN void maya_main_window_on_duplicated (MayaMainWindow* self,
                                     ECalComponent* comp);
static void _vala_ECalComponentId_free (ECalComponentId* self);
static gboolean maya_main_window_real_configure_event (GtkWidget* base,
                                                GdkEventConfigure* event);
static gboolean __lambda193_ (MayaMainWindow* self);
static gboolean ___lambda193__gsource_func (gpointer self);
static gboolean maya_main_window_real_delete_event (GtkWidget* base,
                                             GdkEventAny* event);
VALA_EXTERN GType maya_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MayaApplication, g_object_unref)
VALA_EXTERN void maya_application_ask_for_background (MayaApplication* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
VALA_EXTERN gboolean maya_application_ask_for_background_finish (MayaApplication* self,
                                                     GAsyncResult* _res_);
static void __lambda194_ (MayaMainWindow* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda194__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static GObject * maya_main_window_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
VALA_EXTERN GType maya_view_agenda_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MayaViewAgendaView, g_object_unref)
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
VALA_EXTERN MayaViewCalendarView* maya_view_calendar_view_new (void);
VALA_EXTERN MayaViewCalendarView* maya_view_calendar_view_construct (GType object_type);
VALA_EXTERN MayaViewAgendaView* maya_view_agenda_view_new (void);
VALA_EXTERN MayaViewAgendaView* maya_view_agenda_view_construct (GType object_type);
VALA_EXTERN HdyHeaderBar* maya_view_calendar_view_get_header_bar (MayaViewCalendarView* self);
VALA_EXTERN HdyHeaderBar* maya_view_agenda_view_get_header_bar (MayaViewAgendaView* self);
static void _maya_main_window___lambda195_ (MayaMainWindow* self,
                                     GDateTime* date);
static void __maya_main_window___lambda195__maya_view_calendar_view_on_event_add (MayaViewCalendarView* _sender,
                                                                           GDateTime* date,
                                                                           gpointer self);
static void _maya_main_window___lambda196_ (Block4Data* _data4_,
                                     GDateTime* date);
VALA_EXTERN void maya_view_agenda_view_set_selected_date (MayaViewAgendaView* self,
                                              GDateTime* date);
static void __maya_main_window___lambda196__maya_view_calendar_view_selection_changed (MayaViewCalendarView* _sender,
                                                                                GDateTime* new_date,
                                                                                gpointer self);
static void _maya_main_window_on_remove_maya_view_agenda_view_event_removed (MayaViewAgendaView* _sender,
                                                                      ECalComponent* event,
                                                                      gpointer self);
static void maya_main_window_finalize (GObject * obj);
static GType maya_main_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry MAYA_MAIN_WINDOW_ACTION_ENTRIES[2] = {{MAYA_MAIN_WINDOW_ACTION_NEW_EVENT, _maya_main_window_action_new_event_gsimple_action_activate_callback}, {MAYA_MAIN_WINDOW_ACTION_SHOW_TODAY, _maya_main_window_action_show_today_gsimple_action_activate_callback}};

static inline gpointer
maya_main_window_get_instance_private (MayaMainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MayaMainWindow_private_offset);
}

static void
_maya_main_window_action_new_event_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 29 "../src/MainWindow.vala"
	maya_main_window_action_new_event ((MayaMainWindow*) self);
#line 255 "MainWindow.c"
}

static void
_maya_main_window_action_show_today_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 29 "../src/MainWindow.vala"
	maya_main_window_action_show_today ((MayaMainWindow*) self);
#line 265 "MainWindow.c"
}

MayaMainWindow*
maya_main_window_construct (GType object_type,
                            GtkApplication* application)
{
	MayaMainWindow * self = NULL;
#line 37 "../src/MainWindow.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 38 "../src/MainWindow.vala"
	self = (MayaMainWindow*) g_object_new (object_type, "application", application, "height-request", 400, "icon-name", "io.elementary.calendar", "width-request", 625, NULL);
#line 37 "../src/MainWindow.vala"
	return self;
#line 279 "MainWindow.c"
}

MayaMainWindow*
maya_main_window_new (GtkApplication* application)
{
#line 37 "../src/MainWindow.vala"
	return maya_main_window_construct (MAYA_TYPE_MAIN_WINDOW, application);
#line 287 "MainWindow.c"
}

void
maya_main_window_on_tb_add_clicked (MayaMainWindow* self,
                                    GDateTime* dt)
{
	MayaViewEventDialog* dialog = NULL;
	MayaViewEventDialog* _tmp0_;
#line 93 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/MainWindow.vala"
	g_return_if_fail (dt != NULL);
#line 94 "../src/MainWindow.vala"
	_tmp0_ = maya_view_event_dialog_new (NULL, dt, (GtkWindow*) self);
#line 94 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 94 "../src/MainWindow.vala"
	dialog = _tmp0_;
#line 95 "../src/MainWindow.vala"
	gtk_widget_show_all ((GtkWidget*) dialog);
#line 93 "../src/MainWindow.vala"
	_g_object_unref0 (dialog);
#line 310 "MainWindow.c"
}

static void
maya_main_window_action_new_event (MayaMainWindow* self)
{
	MayaViewCalendarView* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 98 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/MainWindow.vala"
	_tmp0_ = self->calview;
#line 99 "../src/MainWindow.vala"
	_tmp1_ = maya_view_calendar_view_get_selected_date (_tmp0_);
#line 99 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 99 "../src/MainWindow.vala"
	maya_main_window_on_tb_add_clicked (self, _tmp2_);
#line 329 "MainWindow.c"
}

static void
maya_main_window_action_show_today (MayaMainWindow* self)
{
	MayaViewCalendarView* _tmp0_;
#line 102 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/MainWindow.vala"
	_tmp0_ = self->calview;
#line 103 "../src/MainWindow.vala"
	maya_view_calendar_view_today (_tmp0_);
#line 342 "MainWindow.c"
}

static void
maya_main_window_on_remove (MayaMainWindow* self,
                            ECalComponent* comp)
{
	CalendarEventStore* _tmp0_;
	CalendarEventStore* _tmp1_;
	gconstpointer _tmp2_;
#line 106 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/MainWindow.vala"
	g_return_if_fail (comp != NULL);
#line 107 "../src/MainWindow.vala"
	_tmp0_ = calendar_event_store_get_default ();
#line 107 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 107 "../src/MainWindow.vala"
	_tmp2_ = g_object_get_data ((GObject*) comp, "source");
#line 107 "../src/MainWindow.vala"
	calendar_event_store_remove_event (_tmp1_, (ESource*) _tmp2_, comp, E_CAL_OBJ_MOD_THIS);
#line 107 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 366 "MainWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 111 "../src/MainWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 374 "MainWindow.c"
}

void
maya_main_window_on_modified (MayaMainWindow* self,
                              ECalComponent* comp)
{
	ESource* src = NULL;
	gconstpointer _tmp0_;
	ESource* _tmp1_;
	gboolean _tmp2_ = FALSE;
	ESource* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 110 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/MainWindow.vala"
	g_return_if_fail (comp != NULL);
#line 111 "../src/MainWindow.vala"
	_tmp0_ = g_object_get_data ((GObject*) comp, "source");
#line 111 "../src/MainWindow.vala"
	_tmp1_ = _g_object_ref0 ((ESource*) _tmp0_);
#line 111 "../src/MainWindow.vala"
	src = _tmp1_;
#line 113 "../src/MainWindow.vala"
	_tmp3_ = src;
#line 113 "../src/MainWindow.vala"
	_tmp4_ = e_source_get_writable (_tmp3_);
#line 113 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 113 "../src/MainWindow.vala"
	if (_tmp5_ == TRUE) {
#line 406 "MainWindow.c"
		CalendarEventStore* _tmp6_;
		CalendarEventStore* _tmp7_;
		ESource* _tmp8_;
#line 113 "../src/MainWindow.vala"
		_tmp6_ = calendar_event_store_get_default ();
#line 113 "../src/MainWindow.vala"
		_tmp7_ = _tmp6_;
#line 113 "../src/MainWindow.vala"
		_tmp8_ = src;
#line 113 "../src/MainWindow.vala"
		_tmp2_ = calendar_event_store_calclient_is_readonly (_tmp7_, _tmp8_) == FALSE;
#line 113 "../src/MainWindow.vala"
		_g_object_unref0 (_tmp7_);
#line 420 "MainWindow.c"
	} else {
#line 113 "../src/MainWindow.vala"
		_tmp2_ = FALSE;
#line 424 "MainWindow.c"
	}
#line 113 "../src/MainWindow.vala"
	if (_tmp2_) {
#line 428 "MainWindow.c"
		MayaViewEventDialog* dialog = NULL;
		MayaViewEventDialog* _tmp9_;
		MayaViewEventDialog* _tmp10_;
#line 114 "../src/MainWindow.vala"
		_tmp9_ = maya_view_event_dialog_new (comp, NULL, (GtkWindow*) self);
#line 114 "../src/MainWindow.vala"
		g_object_ref_sink (_tmp9_);
#line 114 "../src/MainWindow.vala"
		dialog = _tmp9_;
#line 115 "../src/MainWindow.vala"
		_tmp10_ = dialog;
#line 115 "../src/MainWindow.vala"
		gtk_window_present ((GtkWindow*) _tmp10_);
#line 113 "../src/MainWindow.vala"
		_g_object_unref0 (dialog);
#line 444 "MainWindow.c"
	} else {
#line 117 "../src/MainWindow.vala"
		gdk_beep ();
#line 448 "MainWindow.c"
	}
#line 110 "../src/MainWindow.vala"
	_g_object_unref0 (src);
#line 452 "MainWindow.c"
}

static void
_vala_ECalComponentId_free (ECalComponentId* self)
{
#line 126 "../src/MainWindow.vala"
	g_boxed_free (e_cal_component_id_get_type (), self);
#line 460 "MainWindow.c"
}

void
maya_main_window_on_duplicated (MayaMainWindow* self,
                                ECalComponent* comp)
{
	ESource* src = NULL;
	gconstpointer _tmp0_;
	ESource* _tmp1_;
	gboolean _tmp2_ = FALSE;
	ESource* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 121 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/MainWindow.vala"
	g_return_if_fail (comp != NULL);
#line 122 "../src/MainWindow.vala"
	_tmp0_ = g_object_get_data ((GObject*) comp, "source");
#line 122 "../src/MainWindow.vala"
	_tmp1_ = _g_object_ref0 ((ESource*) _tmp0_);
#line 122 "../src/MainWindow.vala"
	src = _tmp1_;
#line 124 "../src/MainWindow.vala"
	_tmp3_ = src;
#line 124 "../src/MainWindow.vala"
	_tmp4_ = e_source_get_writable (_tmp3_);
#line 124 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 124 "../src/MainWindow.vala"
	if (_tmp5_ == TRUE) {
#line 492 "MainWindow.c"
		CalendarEventStore* _tmp6_;
		CalendarEventStore* _tmp7_;
		ESource* _tmp8_;
#line 124 "../src/MainWindow.vala"
		_tmp6_ = calendar_event_store_get_default ();
#line 124 "../src/MainWindow.vala"
		_tmp7_ = _tmp6_;
#line 124 "../src/MainWindow.vala"
		_tmp8_ = src;
#line 124 "../src/MainWindow.vala"
		_tmp2_ = calendar_event_store_calclient_is_readonly (_tmp7_, _tmp8_) == FALSE;
#line 124 "../src/MainWindow.vala"
		_g_object_unref0 (_tmp7_);
#line 506 "MainWindow.c"
	} else {
#line 124 "../src/MainWindow.vala"
		_tmp2_ = FALSE;
#line 510 "MainWindow.c"
	}
#line 124 "../src/MainWindow.vala"
	if (_tmp2_) {
#line 514 "MainWindow.c"
		ECalComponent* dup_comp = NULL;
		ECalComponent* _tmp9_;
		ECalComponent* _tmp10_;
		ECalComponentId* _tmp11_;
		ECalComponentId* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		MayaViewEventDialog* dialog = NULL;
		ECalComponent* _tmp16_;
		MayaViewEventDialog* _tmp17_;
		MayaViewEventDialog* _tmp18_;
		MayaViewEventDialog* _tmp19_;
#line 125 "../src/MainWindow.vala"
		_tmp9_ = maya_util_copy_ecal_component (comp);
#line 125 "../src/MainWindow.vala"
		dup_comp = _tmp9_;
#line 126 "../src/MainWindow.vala"
		_tmp10_ = dup_comp;
#line 126 "../src/MainWindow.vala"
		_tmp11_ = e_cal_component_get_id (comp);
#line 126 "../src/MainWindow.vala"
		_tmp12_ = _tmp11_;
#line 126 "../src/MainWindow.vala"
		_tmp13_ = e_cal_component_id_get_uid (_tmp12_);
#line 126 "../src/MainWindow.vala"
		_tmp14_ = maya_util_mangle_uid (_tmp13_);
#line 126 "../src/MainWindow.vala"
		_tmp15_ = _tmp14_;
#line 126 "../src/MainWindow.vala"
		e_cal_component_set_uid (_tmp10_, _tmp15_);
#line 126 "../src/MainWindow.vala"
		_g_free0 (_tmp15_);
#line 126 "../src/MainWindow.vala"
		__vala_ECalComponentId_free0 (_tmp12_);
#line 127 "../src/MainWindow.vala"
		_tmp16_ = dup_comp;
#line 127 "../src/MainWindow.vala"
		_tmp17_ = maya_view_event_dialog_new (_tmp16_, NULL, (GtkWindow*) self);
#line 127 "../src/MainWindow.vala"
		g_object_ref_sink (_tmp17_);
#line 127 "../src/MainWindow.vala"
		dialog = _tmp17_;
#line 128 "../src/MainWindow.vala"
		_tmp18_ = dialog;
#line 128 "../src/MainWindow.vala"
		gtk_window_set_transient_for ((GtkWindow*) _tmp18_, (GtkWindow*) self);
#line 130 "../src/MainWindow.vala"
		_tmp19_ = dialog;
#line 130 "../src/MainWindow.vala"
		gtk_window_present ((GtkWindow*) _tmp19_);
#line 124 "../src/MainWindow.vala"
		_g_object_unref0 (dialog);
#line 124 "../src/MainWindow.vala"
		_g_object_unref0 (dup_comp);
#line 570 "MainWindow.c"
	} else {
#line 132 "../src/MainWindow.vala"
		gdk_beep ();
#line 574 "MainWindow.c"
	}
#line 121 "../src/MainWindow.vala"
	_g_object_unref0 (src);
#line 578 "MainWindow.c"
}

static gboolean
__lambda193_ (MayaMainWindow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 142 "../src/MainWindow.vala"
	self->priv->configure_id = (guint) 0;
#line 144 "../src/MainWindow.vala"
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp0_, NULL);
#line 144 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 144 "../src/MainWindow.vala"
	if (_tmp1_) {
#line 595 "MainWindow.c"
		GSettings* _tmp2_;
#line 145 "../src/MainWindow.vala"
		_tmp2_ = maya_application_saved_state;
#line 145 "../src/MainWindow.vala"
		g_settings_set_boolean (_tmp2_, "window-maximized", TRUE);
#line 601 "MainWindow.c"
	} else {
		GSettings* _tmp3_;
		GdkRectangle rect = {0};
		GtkAllocation _tmp4_ = {0};
		GSettings* _tmp5_;
		GdkRectangle _tmp6_;
		GdkRectangle _tmp7_;
#line 147 "../src/MainWindow.vala"
		_tmp3_ = maya_application_saved_state;
#line 147 "../src/MainWindow.vala"
		g_settings_set_boolean (_tmp3_, "window-maximized", FALSE);
#line 150 "../src/MainWindow.vala"
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp4_);
#line 150 "../src/MainWindow.vala"
		rect = _tmp4_;
#line 151 "../src/MainWindow.vala"
		_tmp5_ = maya_application_saved_state;
#line 151 "../src/MainWindow.vala"
		_tmp6_ = rect;
#line 151 "../src/MainWindow.vala"
		_tmp7_ = rect;
#line 151 "../src/MainWindow.vala"
		g_settings_set (_tmp5_, "window-size", "(ii)", _tmp6_.width, _tmp7_.height);
#line 625 "MainWindow.c"
	}
#line 154 "../src/MainWindow.vala"
	result = G_SOURCE_REMOVE;
#line 154 "../src/MainWindow.vala"
	return result;
#line 631 "MainWindow.c"
}

static gboolean
___lambda193__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda193_ ((MayaMainWindow*) self);
#line 141 "../src/MainWindow.vala"
	return result;
#line 641 "MainWindow.c"
}

static gboolean
maya_main_window_real_configure_event (GtkWidget* base,
                                       GdkEventConfigure* event)
{
	MayaMainWindow * self;
	gboolean result;
#line 136 "../src/MainWindow.vala"
	self = (MayaMainWindow*) base;
#line 136 "../src/MainWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 137 "../src/MainWindow.vala"
	if (self->priv->configure_id != ((guint) 0)) {
#line 138 "../src/MainWindow.vala"
		g_source_remove (self->priv->configure_id);
#line 658 "MainWindow.c"
	}
#line 141 "../src/MainWindow.vala"
	self->priv->configure_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda193__gsource_func, g_object_ref (self), g_object_unref);
#line 157 "../src/MainWindow.vala"
	result = GTK_WIDGET_CLASS (maya_main_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
#line 157 "../src/MainWindow.vala"
	return result;
#line 666 "MainWindow.c"
}

static void
__lambda194_ (MayaMainWindow* self,
              GObject* obj,
              GAsyncResult* res)
{
	MayaApplication* app = NULL;
	MayaApplication* _tmp0_;
#line 161 "../src/MainWindow.vala"
	g_return_if_fail (res != NULL);
#line 162 "../src/MainWindow.vala"
	app = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_TYPE_APPLICATION, MayaApplication);
#line 163 "../src/MainWindow.vala"
	_tmp0_ = app;
#line 163 "../src/MainWindow.vala"
	if (maya_application_ask_for_background_finish (_tmp0_, res)) {
#line 164 "../src/MainWindow.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 686 "MainWindow.c"
	} else {
#line 166 "../src/MainWindow.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 690 "MainWindow.c"
	}
}

static void
___lambda194__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 161 "../src/MainWindow.vala"
	__lambda194_ ((MayaMainWindow*) self, source_object, res);
#line 161 "../src/MainWindow.vala"
	g_object_unref (self);
#line 703 "MainWindow.c"
}

static gboolean
maya_main_window_real_delete_event (GtkWidget* base,
                                    GdkEventAny* event)
{
	MayaMainWindow * self;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	gboolean result;
#line 160 "../src/MainWindow.vala"
	self = (MayaMainWindow*) base;
#line 160 "../src/MainWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 161 "../src/MainWindow.vala"
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
#line 161 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 161 "../src/MainWindow.vala"
	maya_application_ask_for_background (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, MAYA_TYPE_APPLICATION, MayaApplication), ___lambda194__gasync_ready_callback, g_object_ref (self));
#line 170 "../src/MainWindow.vala"
	result = GDK_EVENT_STOP;
#line 170 "../src/MainWindow.vala"
	return result;
#line 728 "MainWindow.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 51 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 51 "../src/MainWindow.vala"
	return _data4_;
#line 738 "MainWindow.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 51 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 748 "MainWindow.c"
		MayaMainWindow* self;
#line 51 "../src/MainWindow.vala"
		self = _data4_->self;
#line 51 "../src/MainWindow.vala"
		_g_object_unref0 (_data4_->sidebar);
#line 51 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 51 "../src/MainWindow.vala"
		g_slice_free (Block4Data, _data4_);
#line 758 "MainWindow.c"
	}
}

static void
_maya_main_window___lambda195_ (MayaMainWindow* self,
                                GDateTime* date)
{
#line 86 "../src/MainWindow.vala"
	g_return_if_fail (date != NULL);
#line 86 "../src/MainWindow.vala"
	maya_main_window_on_tb_add_clicked (self, date);
#line 770 "MainWindow.c"
}

static void
__maya_main_window___lambda195__maya_view_calendar_view_on_event_add (MayaViewCalendarView* _sender,
                                                                      GDateTime* date,
                                                                      gpointer self)
{
#line 86 "../src/MainWindow.vala"
	_maya_main_window___lambda195_ ((MayaMainWindow*) self, date);
#line 780 "MainWindow.c"
}

static void
_maya_main_window___lambda196_ (Block4Data* _data4_,
                                GDateTime* date)
{
	MayaMainWindow* self;
	MayaViewAgendaView* _tmp0_;
#line 87 "../src/MainWindow.vala"
	self = _data4_->self;
#line 87 "../src/MainWindow.vala"
	g_return_if_fail (date != NULL);
#line 87 "../src/MainWindow.vala"
	_tmp0_ = _data4_->sidebar;
#line 87 "../src/MainWindow.vala"
	maya_view_agenda_view_set_selected_date (_tmp0_, date);
#line 797 "MainWindow.c"
}

static void
__maya_main_window___lambda196__maya_view_calendar_view_selection_changed (MayaViewCalendarView* _sender,
                                                                           GDateTime* new_date,
                                                                           gpointer self)
{
#line 87 "../src/MainWindow.vala"
	_maya_main_window___lambda196_ (self, new_date);
#line 807 "MainWindow.c"
}

static void
_maya_main_window_on_remove_maya_view_agenda_view_event_removed (MayaViewAgendaView* _sender,
                                                                 ECalComponent* event,
                                                                 gpointer self)
{
#line 88 "../src/MainWindow.vala"
	maya_main_window_on_remove ((MayaMainWindow*) self, event);
#line 817 "MainWindow.c"
}

static GObject *
maya_main_window_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MayaMainWindow * self;
	Block4Data* _data4_;
	GtkIconTheme* default_theme = NULL;
	GtkIconTheme* _tmp19_;
	GtkIconTheme* _tmp20_;
	MayaViewCalendarView* _tmp21_ = NULL;
	MayaViewAgendaView* _tmp22_ = NULL;
	MayaViewAgendaView* _tmp23_;
	GtkPaned* hpaned = NULL;
	GtkPaned* _tmp24_;
	GtkPaned* _tmp25_;
	MayaViewCalendarView* _tmp26_;
	GtkPaned* _tmp27_;
	MayaViewAgendaView* _tmp28_;
	GtkPaned* _tmp29_;
	HdyHeaderGroup* header_group = NULL;
	HdyHeaderGroup* _tmp30_;
	HdyHeaderGroup* _tmp31_;
	MayaViewCalendarView* _tmp32_;
	HdyHeaderBar* _tmp33_;
	HdyHeaderBar* _tmp34_;
	HdyHeaderGroup* _tmp35_;
	MayaViewAgendaView* _tmp36_;
	HdyHeaderBar* _tmp37_;
	HdyHeaderBar* _tmp38_;
	GtkSizeGroup* size_group = NULL;
	GtkSizeGroup* _tmp39_;
	GtkSizeGroup* _tmp40_;
	MayaViewCalendarView* _tmp41_;
	HdyHeaderBar* _tmp42_;
	HdyHeaderBar* _tmp43_;
	GtkSizeGroup* _tmp44_;
	MayaViewAgendaView* _tmp45_;
	HdyHeaderBar* _tmp46_;
	HdyHeaderBar* _tmp47_;
	MayaViewCalendarView* _tmp48_;
	MayaViewCalendarView* _tmp49_;
	MayaViewAgendaView* _tmp50_;
	GSettings* _tmp51_;
	GtkPaned* _tmp52_;
#line 51 "../src/MainWindow.vala"
	parent_class = G_OBJECT_CLASS (maya_main_window_parent_class);
#line 51 "../src/MainWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_TYPE_MAIN_WINDOW, MayaMainWindow);
#line 51 "../src/MainWindow.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 51 "../src/MainWindow.vala"
	_data4_->_ref_count_ = 1;
#line 51 "../src/MainWindow.vala"
	_data4_->self = g_object_ref (self);
#line 52 "../src/MainWindow.vala"
	hdy_init ();
#line 53 "../src/MainWindow.vala"
	g_action_map_add_action_entries ((GActionMap*) self, MAYA_MAIN_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (MAYA_MAIN_WINDOW_ACTION_ENTRIES), self);
#line 883 "MainWindow.c"
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 55 "../src/MainWindow.vala"
		_tmp0_ = maya_main_window_action_accelerators;
#line 55 "../src/MainWindow.vala"
		_tmp1_ = gee_multi_map_get_keys (_tmp0_);
#line 55 "../src/MainWindow.vala"
		_tmp2_ = _tmp1_;
#line 55 "../src/MainWindow.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 55 "../src/MainWindow.vala"
		_tmp4_ = _tmp3_;
#line 55 "../src/MainWindow.vala"
		_g_object_unref0 (_tmp2_);
#line 55 "../src/MainWindow.vala"
		_action_it = _tmp4_;
#line 55 "../src/MainWindow.vala"
		while (TRUE) {
#line 907 "MainWindow.c"
			GeeIterator* _tmp5_;
			gchar* action = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GApplication* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			GeeMultiMap* _tmp12_;
			const gchar* _tmp13_;
			GeeCollection* _tmp14_;
			GeeCollection* _tmp15_;
			gint _tmp16_ = 0;
			gpointer* _tmp17_;
			gchar** _tmp18_;
			gint _tmp18__length1;
#line 55 "../src/MainWindow.vala"
			_tmp5_ = _action_it;
#line 55 "../src/MainWindow.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 55 "../src/MainWindow.vala"
				break;
#line 930 "MainWindow.c"
			}
#line 55 "../src/MainWindow.vala"
			_tmp6_ = _action_it;
#line 55 "../src/MainWindow.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 55 "../src/MainWindow.vala"
			action = (gchar*) _tmp7_;
#line 56 "../src/MainWindow.vala"
			_tmp8_ = g_application_get_default ();
#line 56 "../src/MainWindow.vala"
			_tmp9_ = action;
#line 56 "../src/MainWindow.vala"
			_tmp10_ = g_strconcat (MAYA_MAIN_WINDOW_ACTION_PREFIX, _tmp9_, NULL);
#line 56 "../src/MainWindow.vala"
			_tmp11_ = _tmp10_;
#line 56 "../src/MainWindow.vala"
			_tmp12_ = maya_main_window_action_accelerators;
#line 56 "../src/MainWindow.vala"
			_tmp13_ = action;
#line 56 "../src/MainWindow.vala"
			_tmp14_ = gee_multi_map_get (_tmp12_, _tmp13_);
#line 56 "../src/MainWindow.vala"
			_tmp15_ = _tmp14_;
#line 56 "../src/MainWindow.vala"
			_tmp17_ = gee_collection_to_array (_tmp15_, &_tmp16_);
#line 56 "../src/MainWindow.vala"
			_tmp18_ = _tmp17_;
#line 56 "../src/MainWindow.vala"
			_tmp18__length1 = _tmp16_;
#line 56 "../src/MainWindow.vala"
			gtk_application_set_accels_for_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_application_get_type (), GtkApplication), _tmp11_, _tmp18_);
#line 56 "../src/MainWindow.vala"
			_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 56 "../src/MainWindow.vala"
			_g_object_unref0 (_tmp15_);
#line 56 "../src/MainWindow.vala"
			_g_free0 (_tmp11_);
#line 55 "../src/MainWindow.vala"
			_g_free0 (action);
#line 970 "MainWindow.c"
		}
#line 55 "../src/MainWindow.vala"
		_g_object_unref0 (_action_it);
#line 974 "MainWindow.c"
	}
#line 59 "../src/MainWindow.vala"
	_tmp19_ = gtk_icon_theme_get_default ();
#line 59 "../src/MainWindow.vala"
	default_theme = _tmp19_;
#line 60 "../src/MainWindow.vala"
	_tmp20_ = default_theme;
#line 60 "../src/MainWindow.vala"
	gtk_icon_theme_add_resource_path (_tmp20_, "/io/elementary/calendar");
#line 62 "../src/MainWindow.vala"
	_tmp21_ = maya_view_calendar_view_new ();
#line 62 "../src/MainWindow.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp21_, TRUE);
#line 62 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp21_);
#line 62 "../src/MainWindow.vala"
	_g_object_unref0 (self->calview);
#line 62 "../src/MainWindow.vala"
	self->calview = _tmp21_;
#line 66 "../src/MainWindow.vala"
	_tmp22_ = maya_view_agenda_view_new ();
#line 66 "../src/MainWindow.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp22_, TRUE);
#line 66 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp22_, "width-request", 160, NULL);
#line 66 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp22_);
#line 66 "../src/MainWindow.vala"
	_data4_->sidebar = _tmp22_;
#line 70 "../src/MainWindow.vala"
	_tmp23_ = _data4_->sidebar;
#line 70 "../src/MainWindow.vala"
	gtk_widget_show ((GtkWidget*) _tmp23_);
#line 72 "../src/MainWindow.vala"
	_tmp24_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
#line 72 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp24_);
#line 72 "../src/MainWindow.vala"
	hpaned = _tmp24_;
#line 73 "../src/MainWindow.vala"
	_tmp25_ = hpaned;
#line 73 "../src/MainWindow.vala"
	_tmp26_ = self->calview;
#line 73 "../src/MainWindow.vala"
	gtk_paned_pack1 (_tmp25_, (GtkWidget*) _tmp26_, TRUE, FALSE);
#line 74 "../src/MainWindow.vala"
	_tmp27_ = hpaned;
#line 74 "../src/MainWindow.vala"
	_tmp28_ = _data4_->sidebar;
#line 74 "../src/MainWindow.vala"
	gtk_paned_pack2 (_tmp27_, (GtkWidget*) _tmp28_, FALSE, FALSE);
#line 76 "../src/MainWindow.vala"
	_tmp29_ = hpaned;
#line 76 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp29_);
#line 78 "../src/MainWindow.vala"
	_tmp30_ = hdy_header_group_new ();
#line 78 "../src/MainWindow.vala"
	header_group = _tmp30_;
#line 79 "../src/MainWindow.vala"
	_tmp31_ = header_group;
#line 79 "../src/MainWindow.vala"
	_tmp32_ = self->calview;
#line 79 "../src/MainWindow.vala"
	_tmp33_ = maya_view_calendar_view_get_header_bar (_tmp32_);
#line 79 "../src/MainWindow.vala"
	_tmp34_ = _tmp33_;
#line 79 "../src/MainWindow.vala"
	hdy_header_group_add_header_bar (_tmp31_, _tmp34_);
#line 80 "../src/MainWindow.vala"
	_tmp35_ = header_group;
#line 80 "../src/MainWindow.vala"
	_tmp36_ = _data4_->sidebar;
#line 80 "../src/MainWindow.vala"
	_tmp37_ = maya_view_agenda_view_get_header_bar (_tmp36_);
#line 80 "../src/MainWindow.vala"
	_tmp38_ = _tmp37_;
#line 80 "../src/MainWindow.vala"
	hdy_header_group_add_header_bar (_tmp35_, _tmp38_);
#line 82 "../src/MainWindow.vala"
	_tmp39_ = gtk_size_group_new (GTK_SIZE_GROUP_VERTICAL);
#line 82 "../src/MainWindow.vala"
	size_group = _tmp39_;
#line 83 "../src/MainWindow.vala"
	_tmp40_ = size_group;
#line 83 "../src/MainWindow.vala"
	_tmp41_ = self->calview;
#line 83 "../src/MainWindow.vala"
	_tmp42_ = maya_view_calendar_view_get_header_bar (_tmp41_);
#line 83 "../src/MainWindow.vala"
	_tmp43_ = _tmp42_;
#line 83 "../src/MainWindow.vala"
	gtk_size_group_add_widget (_tmp40_, (GtkWidget*) _tmp43_);
#line 84 "../src/MainWindow.vala"
	_tmp44_ = size_group;
#line 84 "../src/MainWindow.vala"
	_tmp45_ = _data4_->sidebar;
#line 84 "../src/MainWindow.vala"
	_tmp46_ = maya_view_agenda_view_get_header_bar (_tmp45_);
#line 84 "../src/MainWindow.vala"
	_tmp47_ = _tmp46_;
#line 84 "../src/MainWindow.vala"
	gtk_size_group_add_widget (_tmp44_, (GtkWidget*) _tmp47_);
#line 86 "../src/MainWindow.vala"
	_tmp48_ = self->calview;
#line 86 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp48_, "on-event-add", (GCallback) __maya_main_window___lambda195__maya_view_calendar_view_on_event_add, self, 0);
#line 87 "../src/MainWindow.vala"
	_tmp49_ = self->calview;
#line 87 "../src/MainWindow.vala"
	g_signal_connect_data (_tmp49_, "selection-changed", (GCallback) __maya_main_window___lambda196__maya_view_calendar_view_selection_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 88 "../src/MainWindow.vala"
	_tmp50_ = _data4_->sidebar;
#line 88 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp50_, "event-removed", (GCallback) _maya_main_window_on_remove_maya_view_agenda_view_event_removed, self, 0);
#line 90 "../src/MainWindow.vala"
	_tmp51_ = maya_application_saved_state;
#line 90 "../src/MainWindow.vala"
	_tmp52_ = hpaned;
#line 90 "../src/MainWindow.vala"
	g_settings_bind (_tmp51_, "hpaned-position", (GObject*) _tmp52_, "position", G_SETTINGS_BIND_DEFAULT);
#line 51 "../src/MainWindow.vala"
	_g_object_unref0 (size_group);
#line 51 "../src/MainWindow.vala"
	_g_object_unref0 (header_group);
#line 51 "../src/MainWindow.vala"
	_g_object_unref0 (hpaned);
#line 51 "../src/MainWindow.vala"
	block4_data_unref (_data4_);
#line 51 "../src/MainWindow.vala"
	_data4_ = NULL;
#line 51 "../src/MainWindow.vala"
	return obj;
#line 1108 "MainWindow.c"
}

static void
maya_main_window_class_init (MayaMainWindowClass * klass,
                             gpointer klass_data)
{
	GeeHashMultiMap* _tmp0_;
	GeeMultiMap* _tmp1_;
	GeeMultiMap* _tmp2_;
#line 22 "../src/MainWindow.vala"
	maya_main_window_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/MainWindow.vala"
	g_type_class_adjust_private_offset (klass, &MayaMainWindow_private_offset);
#line 22 "../src/MainWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) maya_main_window_real_configure_event;
#line 22 "../src/MainWindow.vala"
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) maya_main_window_real_delete_event;
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = maya_main_window_constructor;
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = maya_main_window_finalize;
#line 35 "../src/MainWindow.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 35 "../src/MainWindow.vala"
	maya_main_window_action_accelerators = (GeeMultiMap*) _tmp0_;
#line 47 "../src/MainWindow.vala"
	_tmp1_ = maya_main_window_action_accelerators;
#line 47 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp1_, MAYA_MAIN_WINDOW_ACTION_NEW_EVENT, "<Control>n");
#line 48 "../src/MainWindow.vala"
	_tmp2_ = maya_main_window_action_accelerators;
#line 48 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp2_, MAYA_MAIN_WINDOW_ACTION_SHOW_TODAY, "<Control>t");
#line 1142 "MainWindow.c"
}

static void
maya_main_window_instance_init (MayaMainWindow * self,
                                gpointer klass)
{
#line 22 "../src/MainWindow.vala"
	self->priv = maya_main_window_get_instance_private (self);
#line 1151 "MainWindow.c"
}

static void
maya_main_window_finalize (GObject * obj)
{
	MayaMainWindow * self;
#line 22 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_TYPE_MAIN_WINDOW, MayaMainWindow);
#line 23 "../src/MainWindow.vala"
	_g_object_unref0 (self->calview);
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (maya_main_window_parent_class)->finalize (obj);
#line 1164 "MainWindow.c"
}

static GType
maya_main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MayaMainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaMainWindow), 0, (GInstanceInitFunc) maya_main_window_instance_init, NULL };
	GType maya_main_window_type_id;
	maya_main_window_type_id = g_type_register_static (hdy_application_window_get_type (), "MayaMainWindow", &g_define_type_info, 0);
	MayaMainWindow_private_offset = g_type_add_instance_private (maya_main_window_type_id, sizeof (MayaMainWindowPrivate));
	return maya_main_window_type_id;
}

GType
maya_main_window_get_type (void)
{
	static volatile gsize maya_main_window_type_id__once = 0;
	if (g_once_init_enter (&maya_main_window_type_id__once)) {
		GType maya_main_window_type_id;
		maya_main_window_type_id = maya_main_window_get_type_once ();
		g_once_init_leave (&maya_main_window_type_id__once, maya_main_window_type_id);
	}
	return maya_main_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

